﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using WSUniversalLib;

namespace UnitTestCalculation
{
    [TestClass]
    public class CalculationTests
    {
        [TestMethod]
        public void Calculation_Count_Return5() //проверка по примеру
        {
            Assert.AreEqual(5, Calculation.GetPriorityForAgent(2, 23, 1.5f));
        }

        [TestMethod]
        public void Calculation_CountMax_Return5() //проверка округления в большую сторону
        {
            Assert.AreEqual(5, Calculation.GetPriorityForAgent(2, 23, 1.4f));
        }

        [TestMethod]
        public void Calculation_Count_Return6()
        {
            Assert.AreEqual(6, Calculation.GetPriorityForAgent(2, 30, 2f));
        }

        [TestMethod]
        public void Calculation_Count_Return74()
        {
            Assert.AreEqual(74, Calculation.GetPriorityForAgent(2, 60, 20));
        }

        [TestMethod]
        public void Calculation_Count_Return149()
        {
            Assert.AreEqual(149, Calculation.GetPriorityForAgent(3, 45, 31));
        }

        [TestMethod]
        public void Calculation_Count_Return300()
        {
            Assert.AreEqual(300, Calculation.GetPriorityForAgent(3, 50, 60));
        }

        [TestMethod]
        public void Calculation_Count_Retur116()
        {
            Assert.AreEqual(116, Calculation.GetPriorityForAgent(1, 54, 43));
        }

        [TestMethod]
        public void Calculation_Count_Return8()
        {
            Assert.AreEqual(5, Calculation.GetPriorityForAgent(2, 65, 23));
        }

        [TestMethod]
        public void Calculation_Count_Return9()
        {
            Assert.AreEqual(5, Calculation.GetPriorityForAgent(2, 78, 80));
        }

        [TestMethod]
        public void Calculation_Count_Return156()
        {
            Assert.AreEqual(156, Calculation.GetPriorityForAgent(2, 90, 40));
        }


        [TestMethod]
        public void Calculation_NonAgeMax_ReturnFalse()
        {
            Assert.AreEqual(-1, Calculation.GetPriorityForAgent(2, 200, 1.4f));
        }

        [TestMethod]
        public void Calculation_NonAgeMin_ReturnFalse()
        {
            Assert.AreEqual(-1, Calculation.GetPriorityForAgent(2, -22, 1.4f));
        }
        [TestMethod]
        public void Calculation_NonType_ReturnFalse() 
        {
            Assert.AreEqual(-1, Calculation.GetPriorityForAgent(0, 23, 1.4f));
        }

        [TestMethod]
        public void Calculation_NonExpirienceMax_ReturnFalse()
        { 
            Assert.AreEqual(-1, Calculation.GetPriorityForAgent(2, 23, 200));
        }
        [TestMethod]
        public void Calculation_NonExpirienceMin_ReturnFalse()
        {
            Assert.AreEqual(-1, Calculation.GetPriorityForAgent(2, 23, -3));
        }
    }
}
